Index: branches/ProgrammableProblem/HeuristicLab.Problems.Programmable.Views/3.3/MultiEncodingView.Designer.cs
===================================================================
--- branches/ProgrammableProblem/HeuristicLab.Problems.Programmable.Views/3.3/MultiEncodingView.Designer.cs	(revision 11952)
+++ branches/ProgrammableProblem/HeuristicLab.Problems.Programmable.Views/3.3/MultiEncodingView.Designer.cs	(revision 11957)
@@ -66,5 +66,12 @@
       this.tabControl.SuspendLayout();
       this.encodingsTabPage.SuspendLayout();
+      this.parametersTabPage.SuspendLayout();
       this.SuspendLayout();
+      // 
+      // parameterCollectionView
+      // 
+      this.parameterCollectionView.Location = new System.Drawing.Point(6, 6);
+      this.parameterCollectionView.Size = new System.Drawing.Size(643, 433);
+      this.parameterCollectionView.TabIndex = 0;
       // 
       // nameTextBox
@@ -92,6 +99,6 @@
       this.encodingsListView.Name = "encodingsListView";
       this.encodingsListView.ShowGroups = false;
-      this.encodingsListView.Size = new System.Drawing.Size(241, 384);
-      this.encodingsListView.TabIndex = 3;
+      this.encodingsListView.Size = new System.Drawing.Size(241, 378);
+      this.encodingsListView.TabIndex = 2;
       this.encodingsListView.UseCompatibleStateImageBehavior = false;
       this.encodingsListView.View = System.Windows.Forms.View.Details;
@@ -113,5 +120,5 @@
       this.addEncodingButton.Name = "addEncodingButton";
       this.addEncodingButton.Size = new System.Drawing.Size(24, 24);
-      this.addEncodingButton.TabIndex = 4;
+      this.addEncodingButton.TabIndex = 0;
       this.addEncodingButton.Text = "+";
       this.addEncodingButton.UseVisualStyleBackColor = true;
@@ -123,5 +130,5 @@
       this.removeEncodingButton.Name = "removeEncodingButton";
       this.removeEncodingButton.Size = new System.Drawing.Size(24, 24);
-      this.removeEncodingButton.TabIndex = 4;
+      this.removeEncodingButton.TabIndex = 1;
       this.removeEncodingButton.Text = "x";
       this.removeEncodingButton.UseVisualStyleBackColor = true;
@@ -144,5 +151,5 @@
       // 
       this.splitContainer.Panel2.Controls.Add(this.encodingDetailsGroupBox);
-      this.splitContainer.Size = new System.Drawing.Size(643, 420);
+      this.splitContainer.Size = new System.Drawing.Size(637, 414);
       this.splitContainer.SplitterDistance = 247;
       this.splitContainer.TabIndex = 5;
@@ -156,6 +163,6 @@
       this.encodingDetailsGroupBox.Location = new System.Drawing.Point(3, 27);
       this.encodingDetailsGroupBox.Name = "encodingDetailsGroupBox";
-      this.encodingDetailsGroupBox.Size = new System.Drawing.Size(386, 390);
-      this.encodingDetailsGroupBox.TabIndex = 1;
+      this.encodingDetailsGroupBox.Size = new System.Drawing.Size(380, 384);
+      this.encodingDetailsGroupBox.TabIndex = 0;
       this.encodingDetailsGroupBox.TabStop = false;
       this.encodingDetailsGroupBox.Text = "Details";
@@ -170,5 +177,5 @@
       this.encodingDetailViewHost.Name = "encodingDetailViewHost";
       this.encodingDetailViewHost.ReadOnly = false;
-      this.encodingDetailViewHost.Size = new System.Drawing.Size(380, 371);
+      this.encodingDetailViewHost.Size = new System.Drawing.Size(374, 365);
       this.encodingDetailViewHost.TabIndex = 0;
       this.encodingDetailViewHost.ViewsLabelVisible = true;
@@ -177,10 +184,12 @@
       // encodingsGroupBox
       // 
+      this.encodingsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.encodingsGroupBox.Controls.Add(this.splitContainer);
-      this.encodingsGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.encodingsGroupBox.Location = new System.Drawing.Point(3, 3);
+      this.encodingsGroupBox.Location = new System.Drawing.Point(6, 6);
       this.encodingsGroupBox.Name = "encodingsGroupBox";
-      this.encodingsGroupBox.Size = new System.Drawing.Size(649, 439);
-      this.encodingsGroupBox.TabIndex = 6;
+      this.encodingsGroupBox.Size = new System.Drawing.Size(643, 433);
+      this.encodingsGroupBox.TabIndex = 0;
       this.encodingsGroupBox.TabStop = false;
       this.encodingsGroupBox.Text = "Encodings";
@@ -197,5 +206,5 @@
       this.tabControl.SelectedIndex = 0;
       this.tabControl.Size = new System.Drawing.Size(663, 471);
-      this.tabControl.TabIndex = 7;
+      this.tabControl.TabIndex = 3;
       // 
       // encodingsTabPage
@@ -212,4 +221,5 @@
       // parametersTabPage
       // 
+      this.parametersTabPage.Controls.Add(this.parameterCollectionView);
       this.parametersTabPage.Location = new System.Drawing.Point(4, 22);
       this.parametersTabPage.Name = "parametersTabPage";
@@ -226,5 +236,4 @@
       this.Name = "MultiEncodingView";
       this.Size = new System.Drawing.Size(666, 497);
-      this.Controls.SetChildIndex(this.parameterCollectionView, 0);
       this.Controls.SetChildIndex(this.nameLabel, 0);
       this.Controls.SetChildIndex(this.nameTextBox, 0);
@@ -240,4 +249,5 @@
       this.tabControl.ResumeLayout(false);
       this.encodingsTabPage.ResumeLayout(false);
+      this.parametersTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();