Index: branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisBottomUpDiversityAnalyzer.cs
===================================================================
--- branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisBottomUpDiversityAnalyzer.cs	(revision 11928)
+++ branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisBottomUpDiversityAnalyzer.cs	(revision 11965)
@@ -22,6 +22,4 @@
 using HeuristicLab.Analysis;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -30,31 +28,4 @@
   [StorableClass]
   public class SymbolicDataAnalysisBottomUpDiversityAnalyzer : SingleObjectivePopulationDiversityAnalyzer {
-    private const string MatchConstantValuesParameterName = "MatchConstantValues";
-    private const string MatchVariableWeightsParameterName = "MatchVariableWeights";
-
-    public IValueParameter<BoolValue> MatchVariableWeightsParameter {
-      get { return (IValueParameter<BoolValue>)Parameters[MatchVariableWeightsParameterName]; }
-    }
-
-    public IValueParameter<BoolValue> MatchConstantValuesParameter {
-      get { return (IValueParameter<BoolValue>)Parameters[MatchConstantValuesParameterName]; }
-    }
-
-    public bool MatchConstantValues {
-      get { return MatchConstantValuesParameter.Value.Value; }
-      set {
-        MatchConstantValuesParameter.Value.Value = value;
-        ((SymbolicExpressionTreeBottomUpSimilarityCalculator)SimilarityCalculator).MatchConstantValues = value;
-      }
-    }
-
-    public bool MatchVariableWeights {
-      get { return MatchVariableWeightsParameter.Value.Value; }
-      set {
-        MatchVariableWeightsParameter.Value.Value = value;
-        ((SymbolicExpressionTreeBottomUpSimilarityCalculator)SimilarityCalculator).MatchVariableWeights = value;
-      }
-    }
-
     [StorableConstructor]
     protected SymbolicDataAnalysisBottomUpDiversityAnalyzer(bool deserializing) : base(deserializing) { }
@@ -62,14 +33,8 @@
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
-      if (!Parameters.ContainsKey(MatchConstantValuesParameterName))
-        Parameters.Add(new ValueParameter<BoolValue>(MatchConstantValuesParameterName, "Specifies if the similarity calculator should match constant values.", new BoolValue(true)));
-      if (!Parameters.ContainsKey(MatchVariableWeightsParameterName))
-        Parameters.Add(new ValueParameter<BoolValue>(MatchVariableWeightsParameterName, "Specifies if the similarity calculator should match variable weights", new BoolValue(true)));
     }
 
     public SymbolicDataAnalysisBottomUpDiversityAnalyzer() {
       SimilarityCalculator = new SymbolicExpressionTreeBottomUpSimilarityCalculator { SolutionVariableName = "SymbolicExpressionTree" };
-      Parameters.Add(new ValueParameter<BoolValue>(MatchConstantValuesParameterName, "Specifies if the similarity calculator should match constant values.", new BoolValue(true)));
-      Parameters.Add(new ValueParameter<BoolValue>(MatchVariableWeightsParameterName, "Specifies if the similarity calculator should match variable weights", new BoolValue(true)));
     }
   }
Index: branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeBottomUpSimilarityCalculator.cs
===================================================================
--- branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeBottomUpSimilarityCalculator.cs	(revision 11928)
+++ branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeBottomUpSimilarityCalculator.cs	(revision 11965)
@@ -36,7 +36,4 @@
   public class SymbolicExpressionTreeBottomUpSimilarityCalculator : SingleObjectiveSolutionSimilarityCalculator, ISymbolicDataAnalysisExpressionSimilarityCalculator {
     private readonly HashSet<string> commutativeSymbols = new HashSet<string> { "Addition", "Multiplication", "Average", "And", "Or", "Xor" };
-    public bool MatchVariableWeights { get; set; }
-    public bool MatchConstantValues { get; set; }
-
     public SymbolicExpressionTreeBottomUpSimilarityCalculator() { }
 
@@ -48,6 +45,4 @@
     protected SymbolicExpressionTreeBottomUpSimilarityCalculator(SymbolicExpressionTreeBottomUpSimilarityCalculator original, Cloner cloner)
       : base(original, cloner) {
-      MatchVariableWeights = original.MatchVariableWeights;
-      MatchConstantValues = original.MatchConstantValues;
     }
 
@@ -214,5 +209,5 @@
     }
 
-    private string Label(ISymbolicExpressionTreeNode node) {
+    private static string Label(ISymbolicExpressionTreeNode node) {
       if (node.SubtreeCount > 0)
         return node.Symbol.Name;
@@ -220,9 +215,9 @@
       var constant = node as ConstantTreeNode;
       if (constant != null)
-        return MatchConstantValues ? constant.Value.ToString(CultureInfo.InvariantCulture) : constant.Symbol.Name;
+        return constant.Value.ToString(CultureInfo.InvariantCulture);
+
       var variable = node as VariableTreeNode;
-      if (variable != null) {
-        return MatchVariableWeights ? variable.Weight + variable.VariableName : variable.VariableName;
-      }
+      if (variable != null)
+        return variable.Weight + variable.VariableName;
 
       return node.ToString();