Index: branches/ALPS/HeuristicLab 3.3.sln
===================================================================
--- branches/ALPS/HeuristicLab 3.3.sln	(revision 11677)
+++ branches/ALPS/HeuristicLab 3.3.sln	(revision 11975)
@@ -21,5 +21,4 @@
 		{DBFD7205-61AF-40EF-8776-3052DEF91CF3} = {DBFD7205-61AF-40EF-8776-3052DEF91CF3}
 		{315BDA09-3F4F-49B3-9790-B37CFC1C5750} = {315BDA09-3F4F-49B3-9790-B37CFC1C5750}
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD} = {489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}
 		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943} = {72104A0B-90E7-42F3-9ABE-9BBBADD4B943}
 		{3081630C-9521-47D7-8075-1777C12F212C} = {3081630C-9521-47D7-8075-1777C12F212C}
@@ -39,4 +38,5 @@
 		{14AB8D24-25BC-400C-A846-4627AA945192} = {14AB8D24-25BC-400C-A846-4627AA945192}
 		{C36BD924-A541-4A00-AFA8-41701378DDC5} = {C36BD924-A541-4A00-AFA8-41701378DDC5}
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D} = {8A0B2A2B-47A7-410D-97A0-4296293BB00D}
 		{D58A232D-04BA-4186-B73E-0EC86FD31ABE} = {D58A232D-04BA-4186-B73E-0EC86FD31ABE}
 		{6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6} = {6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6}
@@ -54,4 +54,5 @@
 		{49F28045-7B5F-411B-8D59-16C846FA26E0} = {49F28045-7B5F-411B-8D59-16C846FA26E0}
 		{1256B945-EEA9-4BE4-9880-76B5B113F089} = {1256B945-EEA9-4BE4-9880-76B5B113F089}
+		{9319C447-8183-4DBC-8145-0E3CF98084CC} = {9319C447-8183-4DBC-8145-0E3CF98084CC}
 		{0C39A349-1979-419A-89BD-E4E2F26BD287} = {0C39A349-1979-419A-89BD-E4E2F26BD287}
 		{C49CB749-8B24-4628-8003-E86475749410} = {C49CB749-8B24-4628-8003-E86475749410}
@@ -86,4 +87,5 @@
 		{7FC70D74-1813-48B7-9CE5-0BD913457579} = {7FC70D74-1813-48B7-9CE5-0BD913457579}
 		{20831A74-D18F-42D9-A667-1CE3AF53DF93} = {20831A74-D18F-42D9-A667-1CE3AF53DF93}
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E} = {F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}
 		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9} = {76945D76-CA61-4147-9DC2-0ACDCDDF87F9}
 		{2E782078-FA81-4B70-B56F-74CE38DAC6C8} = {2E782078-FA81-4B70-B56F-74CE38DAC6C8}
@@ -96,4 +98,5 @@
 		{D767C38D-8014-46B0-9A32-03A3AECCE34A} = {D767C38D-8014-46B0-9A32-03A3AECCE34A}
 		{B1BA398F-953F-4C3A-B07B-1E5E17A27DD9} = {B1BA398F-953F-4C3A-B07B-1E5E17A27DD9}
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F} = {6F023B90-2091-40A9-8AC0-B0338DFF8E5F}
 		{FE856595-64CD-46DA-9CD2-FFF3E6B0D4F2} = {FE856595-64CD-46DA-9CD2-FFF3E6B0D4F2}
 		{9A04599C-D608-4240-8DA6-D41F51C515A3} = {9A04599C-D608-4240-8DA6-D41F51C515A3}
@@ -107,6 +110,8 @@
 		{068C70A7-8CAF-4AB6-8721-4564D62292BC} = {068C70A7-8CAF-4AB6-8721-4564D62292BC}
 		{3083C7AA-5AF4-4C75-BA19-B69B86E2F66A} = {3083C7AA-5AF4-4C75-BA19-B69B86E2F66A}
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3} = {64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}
 		{5211F1AD-BBA2-4C62-8749-DCA0A25CF5D8} = {5211F1AD-BBA2-4C62-8749-DCA0A25CF5D8}
 		{847A8DAE-DB95-4CEE-B48B-EFEE4531D611} = {847A8DAE-DB95-4CEE-B48B-EFEE4531D611}
+		{C38691AE-ECB4-489A-A05D-B035554E0168} = {C38691AE-ECB4-489A-A05D-B035554E0168}
 		{A2330DB0-413D-4424-B4E6-591118E2B9F8} = {A2330DB0-413D-4424-B4E6-591118E2B9F8}
 		{DBECB8B0-B166-4133-BAF1-ED67C3FD7FCA} = {DBECB8B0-B166-4133-BAF1-ED67C3FD7FCA}
@@ -114,4 +119,5 @@
 		{25735DB4-8E54-4A2C-83E3-A60C76565E55} = {25735DB4-8E54-4A2C-83E3-A60C76565E55}
 		{5FEE5DB4-7FD9-4CBD-BEC2-3FEE17B31A94} = {5FEE5DB4-7FD9-4CBD-BEC2-3FEE17B31A94}
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8} = {052881B5-4D5D-41C5-9555-FECA01E0BAC8}
 		{F4539FB6-4708-40C9-BE64-0A1390AEA197} = {F4539FB6-4708-40C9-BE64-0A1390AEA197}
 		{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C} = {A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}
@@ -136,4 +142,5 @@
 		{88B9B0E3-344E-4196-82A3-0F9732506FE8} = {88B9B0E3-344E-4196-82A3-0F9732506FE8}
 		{AE5B1CE5-9862-4D6F-A700-D72CD9AEA295} = {AE5B1CE5-9862-4D6F-A700-D72CD9AEA295}
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F} = {FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}
 		{C9CF6AE8-4637-4A75-9141-042F479B5D50} = {C9CF6AE8-4637-4A75-9141-042F479B5D50}
 		{A9E282EA-180F-4233-B809-AEDF0787545C} = {A9E282EA-180F-4233-B809-AEDF0787545C}
@@ -143,4 +150,5 @@
 		{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937} = {BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}
 		{6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5} = {6AE0E1F5-D3FF-43A3-90E1-2435E7493FB5}
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9} = {EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}
 		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32} = {E4EE5AFB-D552-447B-8A16-6CBE7938AF32}
 	EndProjectSection
@@ -185,6 +193,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Operators.Views.GraphVisualization-3.3", "HeuristicLab.Operators.Views.GraphVisualization\3.3\HeuristicLab.Operators.Views.GraphVisualization-3.3.csproj", "{57F38579-409D-4DD8-AB19-3F2C4A665126}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CodeEditor-3.3", "HeuristicLab.CodeEditor\3.3\HeuristicLab.CodeEditor-3.3.csproj", "{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Optimization-3.3", "HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj", "{14AB8D24-25BC-400C-A846-4627AA945192}"
@@ -409,5 +415,23 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.DataPreprocessing.Views-3.4", "HeuristicLab.DataPreprocessing.Views\3.4\HeuristicLab.DataPreprocessing.Views-3.4.csproj", "{3FC7515E-D8A0-41FE-8CFA-50E3ADA61A1E}"
 EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Analysis.Statistics.Views-3.3", "HeuristicLab.Analysis.Statistics.Views\3.3\HeuristicLab.Analysis.Statistics.Views-3.3.csproj", "{052881B5-4D5D-41C5-9555-FECA01E0BAC8}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CodeEditor-3.4", "HeuristicLab.CodeEditor\3.4\HeuristicLab.CodeEditor-3.4.csproj", "{C38691AE-ECB4-489A-A05D-B035554E0168}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.ParameterlessPopulationPyramid-3.3", "HeuristicLab.Algorithms.ParameterlessPopulationPyramid\3.3\HeuristicLab.Algorithms.ParameterlessPopulationPyramid-3.3.csproj", "{9319C447-8183-4DBC-8145-0E3CF98084CC}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.BinaryVector-3.3", "HeuristicLab.Problems.BinaryVector\3.3\HeuristicLab.Problems.BinaryVector-3.3.csproj", "{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}"
+EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Algorithms.ALPS-3.3", "HeuristicLab.Algorithms.ALPS\3.3\HeuristicLab.Algorithms.ALPS-3.3.csproj", "{59F354CB-FE13-4253-AED2-AD86372BEC27}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.Programmable-3.3", "HeuristicLab.Problems.Programmable\3.3\HeuristicLab.Problems.Programmable-3.3.csproj", "{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.Programmable.Views-3.3", "HeuristicLab.Problems.Programmable.Views\3.3\HeuristicLab.Problems.Programmable.Views-3.3.csproj", "{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ExternalEvaluation-3.4", "HeuristicLab.Problems.ExternalEvaluation\3.4\HeuristicLab.Problems.ExternalEvaluation-3.4.csproj", "{8A0B2A2B-47A7-410D-97A0-4296293BB00D}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ExternalEvaluation.GP-3.5", "HeuristicLab.Problems.ExternalEvaluation.GP\3.5\HeuristicLab.Problems.ExternalEvaluation.GP-3.5.csproj", "{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ExternalEvaluation.Views-3.4", "HeuristicLab.Problems.ExternalEvaluation.Views\3.4\HeuristicLab.Problems.ExternalEvaluation.Views-3.4.csproj", "{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}"
 EndProject
 Global
@@ -673,16 +697,4 @@
 		{57F38579-409D-4DD8-AB19-3F2C4A665126}.Release|x86.ActiveCfg = Release|x86
 		{57F38579-409D-4DD8-AB19-3F2C4A665126}.Release|x86.Build.0 = Release|x86
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Debug|x64.ActiveCfg = Debug|x64
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Debug|x64.Build.0 = Debug|x64
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Debug|x86.ActiveCfg = Debug|x86
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Debug|x86.Build.0 = Debug|x86
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Release|Any CPU.Build.0 = Release|Any CPU
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Release|x64.ActiveCfg = Release|x64
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Release|x64.Build.0 = Release|x64
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Release|x86.ActiveCfg = Release|x86
-		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}.Release|x86.Build.0 = Release|x86
 		{14AB8D24-25BC-400C-A846-4627AA945192}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{14AB8D24-25BC-400C-A846-4627AA945192}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1981,4 +1993,112 @@
 		{3FC7515E-D8A0-41FE-8CFA-50E3ADA61A1E}.Release|x86.ActiveCfg = Release|x86
 		{3FC7515E-D8A0-41FE-8CFA-50E3ADA61A1E}.Release|x86.Build.0 = Release|x86
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Debug|x64.ActiveCfg = Debug|x64
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Debug|x64.Build.0 = Debug|x64
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Debug|x86.ActiveCfg = Debug|x86
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Debug|x86.Build.0 = Debug|x86
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Release|Any CPU.Build.0 = Release|Any CPU
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Release|x64.ActiveCfg = Release|x64
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Release|x64.Build.0 = Release|x64
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Release|x86.ActiveCfg = Release|x86
+		{052881B5-4D5D-41C5-9555-FECA01E0BAC8}.Release|x86.Build.0 = Release|x86
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Debug|x64.ActiveCfg = Debug|x64
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Debug|x64.Build.0 = Debug|x64
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Debug|x86.ActiveCfg = Debug|x86
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Debug|x86.Build.0 = Debug|x86
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Release|Any CPU.Build.0 = Release|Any CPU
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Release|x64.ActiveCfg = Release|x64
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Release|x64.Build.0 = Release|x64
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Release|x86.ActiveCfg = Release|x86
+		{C38691AE-ECB4-489A-A05D-B035554E0168}.Release|x86.Build.0 = Release|x86
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Debug|x64.ActiveCfg = Debug|x64
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Debug|x64.Build.0 = Debug|x64
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Debug|x86.ActiveCfg = Debug|x86
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Debug|x86.Build.0 = Debug|x86
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Release|Any CPU.Build.0 = Release|Any CPU
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Release|x64.ActiveCfg = Release|x64
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Release|x64.Build.0 = Release|x64
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Release|x86.ActiveCfg = Release|x86
+		{9319C447-8183-4DBC-8145-0E3CF98084CC}.Release|x86.Build.0 = Release|x86
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Debug|x64.ActiveCfg = Debug|x64
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Debug|x64.Build.0 = Debug|x64
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Debug|x86.ActiveCfg = Debug|x86
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Debug|x86.Build.0 = Debug|x86
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Release|Any CPU.Build.0 = Release|Any CPU
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Release|x64.ActiveCfg = Release|x64
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Release|x64.Build.0 = Release|x64
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Release|x86.ActiveCfg = Release|x86
+		{FC627BE5-0F93-47D8-BD2E-530EA2B8AA5F}.Release|x86.Build.0 = Release|x86
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Debug|x64.ActiveCfg = Debug|x64
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Debug|x64.Build.0 = Debug|x64
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Debug|x86.ActiveCfg = Debug|x86
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Debug|x86.Build.0 = Debug|x86
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Release|Any CPU.Build.0 = Release|Any CPU
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Release|x64.ActiveCfg = Release|x64
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Release|x64.Build.0 = Release|x64
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Release|x86.ActiveCfg = Release|x86
+		{EE07BFF8-B23D-41F5-8AD7-AC9598D7A2C9}.Release|x86.Build.0 = Release|x86
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Debug|x64.ActiveCfg = Debug|x64
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Debug|x64.Build.0 = Debug|x64
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Debug|x86.ActiveCfg = Debug|x86
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Debug|x86.Build.0 = Debug|x86
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Release|Any CPU.Build.0 = Release|Any CPU
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Release|x64.ActiveCfg = Release|x64
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Release|x64.Build.0 = Release|x64
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Release|x86.ActiveCfg = Release|x86
+		{6F023B90-2091-40A9-8AC0-B0338DFF8E5F}.Release|x86.Build.0 = Release|x86
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Debug|x64.ActiveCfg = Debug|x64
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Debug|x64.Build.0 = Debug|x64
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Debug|x86.ActiveCfg = Debug|x86
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Debug|x86.Build.0 = Debug|x86
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Release|Any CPU.Build.0 = Release|Any CPU
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Release|x64.ActiveCfg = Release|x64
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Release|x64.Build.0 = Release|x64
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Release|x86.ActiveCfg = Release|x86
+		{8A0B2A2B-47A7-410D-97A0-4296293BB00D}.Release|x86.Build.0 = Release|x86
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Debug|x64.ActiveCfg = Debug|x64
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Debug|x64.Build.0 = Debug|x64
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Debug|x86.ActiveCfg = Debug|x86
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Debug|x86.Build.0 = Debug|x86
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Release|Any CPU.Build.0 = Release|Any CPU
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Release|x64.ActiveCfg = Release|x64
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Release|x64.Build.0 = Release|x64
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Release|x86.ActiveCfg = Release|x86
+		{64CC53AC-156B-4D8A-8DB0-B68990BEA4D3}.Release|x86.Build.0 = Release|x86
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Debug|x64.ActiveCfg = Debug|x64
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Debug|x64.Build.0 = Debug|x64
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Debug|x86.ActiveCfg = Debug|x86
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Debug|x86.Build.0 = Debug|x86
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Release|Any CPU.Build.0 = Release|Any CPU
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Release|x64.ActiveCfg = Release|x64
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Release|x64.Build.0 = Release|x64
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Release|x86.ActiveCfg = Release|x86
+		{F7E5B975-FDF2-45A4-91CB-FF6D3C33D65E}.Release|x86.Build.0 = Release|x86
 		{59F354CB-FE13-4253-AED2-AD86372BEC27}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{59F354CB-FE13-4253-AED2-AD86372BEC27}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1997,6 +2117,3 @@
 		HideSolutionNode = FALSE
 	EndGlobalSection
-	GlobalSection(Performance) = preSolution
-		HasPerformanceSessions = true
-	EndGlobalSection
 EndGlobal